// File: cmps.h
//
// Created: Mon Jan 26 14:14:54 2004
//
// $Id: cmps.h,v 1.3 2004/04/24 14:47:19 sav Exp $
//

#ifndef __CMPS2_H__
#define __CMPS2_H__

#include "table.h"
#include "config.h"
#include "search.h"
#include <string>


#include "typedefs.h"

template<class TD2 > class str_cmp {
private:
  NodeConst::comparison_type tt;
  std::string s2;
  const char* data_top;
public:
  str_cmp(NodeConst::comparison_type t, const char* cs2, const char* cdata_top) : tt(t), s2(cs2), data_top(cdata_top) { }
  int operator()(const tb_iter< noid_type> & p) const {
    const char* str =  (data_top + p.get_key_checked()) ;
    switch (tt) {
#ifdef GCC2
     case NodeConst::PREFIX:  return s2.compare( str, 0, s2.length());
#else
     case NodeConst::PREFIX:
       long len;
       len = s2.length();
       return s2.compare( 0, len, str, len);
#endif
    case NodeConst::FULL:    return s2.compare(str);
    default:      throw sdb_error("Internal error in str_cmp: Some bad?");
    }
  }
};

template<class TD1, class TD2> class num_cmp {
   TD1 a;
public:
  num_cmp(TD1 ca) : a(ca) {}
  int operator()(const tb_iter<TD1> & p) const {
    TD1 c = a-p.get_key_checked();
    if (c<0) return -1;
    if (c==0) return 0;
    return 1;
  }
};

template<class TD1, class TD2> class int8tmp_cmp {
  int8 a;
  const char* data_top;
public:
  int8tmp_cmp(int8 ca, const char* cdata_top) : a(ca), data_top(cdata_top) {}
  int operator()(const tb_iter<TD1>& p) const {
    offset_type c = p.get_key_checked();
    const int8 *v = (const int8 *)(data_top+c);
    if (a<*v) return -1;
    if (a>*v) return 1;
    return 0;
  }
};



#endif

//  Local Variables:
//  mode: c++
//  End:
