// File: nrif.h
//
// Created: Fri Dec 26 13:04:46 2003
//
// $Id: nrif.h,v 1.3 2004/10/29 13:28:59 sav Exp $
//

#ifndef __NRIF_H__
#define __NRIF_H__

#include <string>
#include <utility>

#include "sdb_error.h"
#include "search.h"
#include "table.h"
#include "tb_iter.h"

//"nrif.cc"
#include<iostream>
#include "cmps.h"

/*
    print $IDXFILE pack("L",$self->{VALTYPE});
    print $IDXFILE pack("L",$self->{ELNUM});
    print $IDXFILE Data::Array2ArrayMap::SDB::Writer::packoffset($self->{FIND_TABLE_OFFSET}); 
    print $IDXFILE Data::Array2ArrayMap::SDB::Writer::packoffset($self->{GET_TABLE_OFFSET}); 
    print $IDXFILE pack("L",$flags); 
    print $IDXFILE pack("L",$DEFAULT_VALUE); 
*/

/* nrif header -  1 bytes units */
#define MAGICNRIF_OFFSET 0
#define KEYTYPE_OFFSET 4
#define VALTYPE_OFFSET 8
#define SIZE_OFFSET 12
#define GET_TABLE_OFFSET 16
#define FIND_TABLE_OFFSET 20
#define FLAGS_OFFSET 24
#define DEFVAL_OFFSET 28
/*
#define VALTYPE_OFFSET 0
#define SIZE_OFFSET 4
#define GET_TABLE_OFFSET 8
#define FIND_TABLE_OFFSET 12
#define FLAGS_OFFSET 16
#define DEFVAL_OFFSET 20
*/

#define KEYTYPE (*((int*) (top+KEYTYPE_OFFSET)))
#define VALTYPE (*((int*) (top+VALTYPE_OFFSET)))
#define SIZE (*((int*) (top+SIZE_OFFSET)))
#define FIND_TABLE (*((offset_type*) (top+FIND_TABLE_OFFSET)))
#define GET_TABLE (*((offset_type*) (top+GET_TABLE_OFFSET)))
#define FLAGS (*((int*) (top+FLAGS_OFFSET)))
#define DEFVAL (*((int*) (top+DEFVAL_OFFSET)))
 
template<class KeyType, class ValType> class NodeRIndex {
  char *top;
protected:
  table<noid_type, noid_type> find_map;
  table<noid_type, noid_type> get_map;
public:
  void init(void *ctop) {
    top        = (char *)ctop;
    // if it is 0 then table is empty
    if (GET_TABLE > 0) get_map.init((NodeConst::TYPE)KEYTYPE, (NodeConst::TYPE)VALTYPE, (char *)top+GET_TABLE, SIZE, top, isGetUnique(), hasDefVal(), get_defVal());
    if (FIND_TABLE > 0)  find_map.init((NodeConst::TYPE) VALTYPE, (NodeConst::TYPE)KEYTYPE, (char *)top+FIND_TABLE, SIZE, top, isFindUnique(), false, 0);
  }
  NodeRIndex(void *ctop) { init(ctop); }

  table<ValType, KeyType>& get_find_map(void) { return find_map; }
  table<KeyType, ValType>& get_get_map(void) { return get_map; }

  NodeConst::TYPE get_keytype(void) const { return (NodeConst::TYPE) KEYTYPE;}
  NodeConst::TYPE get_valtype(void) const { return (NodeConst::TYPE) VALTYPE;}
  // default value or offset
  noid_type get_defVal(void) const { return DEFVAL;}
  size_t get_size(void) const { return SIZE;}
  char *get_top(void) const { return top; }
  // bit set of NodeRIndex flags
  bool isGetUnique(void)  const { return NodeConst::GETUNIQUE  == (FLAGS & NodeConst::GETUNIQUE);  }
  bool isFindUnique(void) const { return NodeConst::FINDUNIQUE == (FLAGS & NodeConst::FINDUNIQUE); }
  bool hasDefVal(void)    const { return NodeConst::HASDEFVAL  == (FLAGS & NodeConst::HASDEFVAL);  }

std::pair< tb_iter<KeyType>, tb_iter<KeyType> > 
get(KeyType key) {
  return get_map.map_numeric_key(key);
}

  /*
std::pair< tb_iter<KeyType>, tb_iter<KeyType> > 
find(KeyType key, NodeConst::comparison_type tt = NodeConst::FULL) {
  return find_map.map_key(key, tt);
}
  */

};

#endif

//  Local Variables:
//  mode: c++
//  End:
